/***************************************************************************
Title: PCA9539 library (DT-I/O I2C to Parallel Converter)
by: agni

This file is free software; you can redistribute it and/or modify
it under the terms of either the GNU General Public License version 2
or the GNU Lesser General Public License version 2.1, both as
published by the Free Software Foundation.
***************************************************************************/

#ifndef DTIOI2CtoParallelConverter_h
#define DTIOI2CtoParallelConverter_h

#include <Arduino.h>
#include <Wire.h>

//PCA9539 Command Byte
#define INPUTPORT0	0x00
#define INPUTPORT1	0x01
#define OUTPUTPORT0	0x02
#define OUTPUTPORT1	0x03
#define POLINVPORT0	0x04
#define POLINVPORT1	0x05
#define CONFIGPORT0	0x06
#define CONFIGPORT1	0x07

#define ALLOUTPUT	0x00
#define ALLINPUT	0xFF

class DTIOI2CtoParallelConverter
{
	public :
		DTIOI2CtoParallelConverter(byte SlaveAddress);

		bool twiRead(byte &registerAddress);
		bool twiWrite(byte registerAddress, byte dataWrite);

		bool pinMode0(byte pinNumber, bool state);
		bool pinMode1(byte pinNumber, bool state);
		bool portMode0(byte value);
		bool portMode1(byte value);

		bool digitalWrite0(byte pinNumber, bool state);
		bool digitalWrite1(byte pinNumber, bool state);
		bool digitalWritePort0(byte value);
		bool digitalWritePort1(byte value);
		
		bool digitalRead0(byte &pinNumber);
		bool digitalRead1(byte &pinNumber);
		bool digitalReadPort0(byte &value);
		bool digitalReadPort1(byte &value);

	private :
		int _SlaveAddress;
};

#endif
